package com.hotwj.platform.securityManagement.hiddenDanger.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.securityManagement.hiddenDanger.domain.HotHiddenDangerReviewRecord;
import com.hotwj.platform.securityManagement.hiddenDanger.domain.bo.HotHiddenDangerReviewRecordBo;
import com.hotwj.platform.securityManagement.hiddenDanger.domain.vo.HotHiddenDangerReviewRecordVo;
import com.hotwj.platform.securityManagement.hiddenDanger.mapper.HotHiddenDangerReviewRecordMapper;
import com.hotwj.platform.securityManagement.hiddenDanger.service.IHotHiddenDangerReviewRecordService;
import lombok.RequiredArgsConstructor;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;

/**
 * 隐患复查记录Service业务层处理
 *
 * @author shihongwei
 * @date 2026-01-04
 */
@RequiredArgsConstructor
@Service
public class HotHiddenDangerReviewRecordServiceImpl implements IHotHiddenDangerReviewRecordService {

    private final HotHiddenDangerReviewRecordMapper baseMapper;

    /**
     * 查询隐患复查记录
     *
     * @param id 主键
     * @return 隐患复查记录
     */
    @Override
    public HotHiddenDangerReviewRecordVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询隐患复查记录列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 隐患复查记录分页列表
     */
    @Override
    public TableDataInfo<HotHiddenDangerReviewRecordVo> queryPageList(HotHiddenDangerReviewRecordBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotHiddenDangerReviewRecord> lqw = buildQueryWrapper(bo);
        Page<HotHiddenDangerReviewRecordVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的隐患复查记录列表
     *
     * @param bo 查询条件
     * @return 隐患复查记录列表
     */
    @Override
    public List<HotHiddenDangerReviewRecordVo> queryList(HotHiddenDangerReviewRecordBo bo) {
        LambdaQueryWrapper<HotHiddenDangerReviewRecord> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotHiddenDangerReviewRecord> buildQueryWrapper(HotHiddenDangerReviewRecordBo bo) {
        LambdaQueryWrapper<HotHiddenDangerReviewRecord> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getHiddenDangerId() != null, HotHiddenDangerReviewRecord::getHiddenDangerId, bo.getHiddenDangerId());
        lqw.eq(bo.getReviewerId() != null, HotHiddenDangerReviewRecord::getReviewerId, bo.getReviewerId());
        lqw.like(StringUtils.isNotBlank(bo.getReviewerName()), HotHiddenDangerReviewRecord::getReviewerName, bo.getReviewerName());
        lqw.eq(bo.getReviewTime() != null, HotHiddenDangerReviewRecord::getReviewTime, bo.getReviewTime());
        lqw.like(StringUtils.isNotBlank(bo.getReviewConclusion()), HotHiddenDangerReviewRecord::getReviewConclusion, bo.getReviewConclusion());
        lqw.eq(bo.getIsQualified() != null, HotHiddenDangerReviewRecord::getIsQualified, bo.getIsQualified());
        return lqw;
    }

    /**
     * 新增隐患复查记录
     *
     * @param bo 隐患复查记录
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotHiddenDangerReviewRecordBo bo) {
        HotHiddenDangerReviewRecord add = MapstructUtils.convert(bo, HotHiddenDangerReviewRecord.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改隐患复查记录
     *
     * @param bo 隐患复查记录
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotHiddenDangerReviewRecordBo bo) {
        HotHiddenDangerReviewRecord update = MapstructUtils.convert(bo, HotHiddenDangerReviewRecord.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotHiddenDangerReviewRecord entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除隐患复查记录信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
